#include "../../../lib/std.mi"
#include "../../../lib/config.mi"

// -------------------------------------------------------
// Made by: David Kohen (skin-support@dudy.mine.nu)
// Basic script: Sebastian Kroll
// -------------------------------------------------------

#define AROW_VISIBLE_LOC "76"
#define AROW_INVISIBLE_LOC "-32"

// Diffrence to move between options in the menu and values in the equalizer
#define MIN_DIFF_FOR_MOVE (32)
#define VOL_SENSITIVITY (4)

// Locations for menu moves
#define X_HIDDEN_LEFT (-122)
#define X_HIDDEN_RIGHT (122)
#define X_HIDDEN_LEFT_STR "-122"
#define X_HIDDEN_RIGHT_STR "122"
#define X_VISIBLE (-2)
#define BLENDER_TIME 0.2

// Speed of menu transitions
#define HIDE_SPEED (0.7)
#define SHOW_SPEED (0.5)

// Clock configuration key
#define CLOCK_CFG "iPod Skin","Show Clock In iPod"
#define BG_TIMER "iPod Skin","Backlight Timer"
#define THEME "iPod Skin","Theme"
#define CUR_LANG "iPod Skin","Language to use"
#define TXT_COLOR_GREEN "181,178,161"
#define TXT_COLOR_BLUE "195,212,233"

// Scroll speed options, change the equalizer custom menu

// 1.2 takes about 7.5 seconds to decreese to 1, 1.3 takes 5 and 1.4 takes 4
#define SPEED_FORMULA / 1.2
// Initial speed
#define SPEED_MAX (20)
// Rate in which to decrese the speed
#define SPEED_VAL (50)

Function updateItem(Boolean Negative);
Function SwitchMenu(Int DestMenu, Boolean Reverse);
Function ResetItems(Int d);
Function UpdateBigMenu(Boolean Reverse);
Function StopFlashing();
Function String GetEqBandName(Int BandNum);
Function illuminator();
Function updateItemColor(Int e, int f);


Global Group infogroup;
Global Group seekergroup;
Global Group seekergroup2;
Global Group menugroup;
Global Group menugroup2;
Global Group eqgroup;
Global Group thgroup;
Global Group visgroup;
Global Group volgroup;

Global Button menubutton, SelectButton, prevButton, nextbutton, playButton, pauseButton, th_left, th_right, bat;
Global layout mainnormal;
Global Int menustate;
Global int CurrentItem;
Global int CurrentMenu;
Global Boolean SelectingItem;
Global Boolean EditingItem;
Global Text TitleBar;
Global Int MenuMax;
Global Int CurrMenuMin;
Global Int CurrMenuMax;
Global int SpeedInc;
Global int mouseonbutton;
Global int force_illum, skip_action, downvalue;

Global AnimatedLayer Volume;
Global Map volMap;
Global Map menuMap;
Global Map nextMap;
Global Map playMap;
Global Map prevMap;
Global float OldValue;

Global Timer Clock, Clock2;
Global Timer FlashSelected;
Global Timer Speed;
Global Timer Blender;
Global Timer BackToPlay;
Global Timer Illum_by_menu;
Global Timer SeekerPos,Seekerback,Volback;

Global Timer SleepTimer,VolDownTimer;
Global Int Sleep_state, saveVol, steps_left;
Global Layer Sleep_Clock;
Global Text Sleep_Left;

Global Boolean FlashOn,IlluOn;
Global Int VolChanging, MouseDown;

Global Layer illum,seeker_pos;


Global ConfigAttribute Shuffle_Mode, Repeat_Mode, CrossFade_Mode;


System.onScriptLoaded()
{
	volMap = new Map;
	volMap.loadMap("Volume.map");

	nextMap = new Map;
	nextMap.loadMap("next.map");

	menuMap = new Map;
	menuMap.loadMap("menu.map");

	playMap = new Map;
	playMap.loadMap("play.map");

	prevMap = new Map;
	prevMap.loadMap("prev.map");

	Clock = new Timer;
	Clock2 = new Timer;
	SeekerPos = new Timer;
	SeekerPos.setDelay(250);

	FlashSelected = new timer;
	Speed = new Timer;

	Layout mainnormal = getContainer("Main").getLayout("normal");
	menubutton = mainnormal.getObject("Menu");

	TitleBar = getContainer("Main").getLayout("normal").getObject("ipodheadline");

	mouseonbutton = 0;
	force_illum = 0;
	skip_action = 0;
	Sleep_state = 0;
	saveVol = 0;

	infogroup = mainnormal.getObject("infowindow");
	seekergroup = mainnormal.getObject("seekerwindow");
	seekergroup2 = mainnormal.getObject("seekerwindow2");
	menugroup = mainnormal.getObject("MenuBase");
	menugroup2 = mainnormal.getObject("MenuBase2");
	eqgroup = mainnormal.getObject("eqwindow");
	thgroup = mainnormal.getObject("thingerwindow");
	volgroup = mainnormal.getObject("volumewindow");
	visgroup = mainnormal.getObject("viswindow");

	seeker_pos = seekergroup2.getObject("seekerposition_s2");

	SelectButton = mainnormal.getObject("Select");
	prevButton = mainnormal.getObject("Prev");
	nextButton = mainnormal.getObject("Next");
	pauseButton = mainnormal.getObject("Pause");
	playButton = mainnormal.getObject("Play");
	bat = mainnormal.getObject("bat");

	Sleep_Left = infogroup.getObject("sleepleft");
	Sleep_Clock = infogroup.getObject("sleepclock");

	prevbutton.hide();
	nextbutton.hide();
	playbutton.hide();
	pausebutton.hide();
	menubutton.hide();

	th_left = thgroup.getObject("ScrollLeft");
	th_right = thgroup.getObject("ScrollRight");

	Layer sidebarL = mainnormal.getObject("sidebarleft");
	Layer sidebarR = mainnormal.getObject("sidebarright");
	Layer innershadow = mainnormal.getObject("innershadow");

  	illum = mainnormal.getObject("illuminator");
  	illum.setalpha(0);

	seekergroup2.setXmlParam("x",X_HIDDEN_RIGHT_STR);
	menustate = 1;

	volume = mainnormal.getObject("Volume-Ani-Layer");

	ConfigItem ParantItem = Config.getItem("Playlist editor");
	if (ParantItem != NULL)
	{
		Repeat_Mode = ParantItem.getAttribute("repeat");
		Shuffle_Mode = ParantItem.getAttribute("shuffle");
	}

	ParantItem = Config.getItem("Audio options");
	if (ParantItem != NULL) CrossFade_Mode = ParantItem.getAttribute("Enable crossfading");

	sidebarL.bringToFront();
	sidebarR.bringToFront();
	innershadow.bringtofront();

	SelectingItem = false;
	EditingItem = false;
	CurrentItem = 1;
	System.setPrivateInt("iPod-Menu","IsOn",0);
	System.setPrivateInt("Seeking","IsOn",0);

	SleepTimer = new Timer;
	VolDownTimer = new Timer;
	SleepTimer.setDelay(1000*60);
	VolDownTimer.setDelay(100);

	Illum_by_menu = new Timer;
	Illum_by_menu.setDelay(2000);

	Seekerback = new Timer;
	Seekerback.setDelay(5000);

	Volback = new Timer;
	VolBack.setDelay(2000);

	Clock.setDelay(100);
	FlashSelected.setDelay(500);
	Speed.setDelay(100);
	if (System.getPrivateString(CLOCK_CFG,"0") == "1") Clock.start();
	CurrentMenu = 0;
	MenuMax = 6;
	CurrMenuMin = 1;
	CurrMenuMax = 6;
	FlashOn = true;
	downvalue = 0;
	steps_left = 0;

	Int c;
	c = System.getPrivateInt(BG_TIMER,1);

  	BackToPlay = new timer;
  	BackToPlay.setDelay(10000);

  	Blender = new timer;
	IlluOn = false;

  	if (c == 1)
  	{
    	Blender.setDelay(1000);
  	}
 	else if (c == 2)
  	{
    	Blender.setDelay(1000);
  	}
  	else if (c == 3)
  	{
    	Blender.setDelay(2000);
  	}
  	else if (c == 4)
  	{
    	Blender.setDelay(5000);
  	}
  	else if (c == 5)
  	{
    	Blender.setDelay(10000);
  	}
  	else if (c == 6)
  	{
    	Blender.setDelay(1000);
    	//illum.setTargetX(12);
    	//illum.setTargetY(3);
    	//illum.setTargetW(101);
    	//illum.setTargetH(86);
    	illum.setTargetSpeed(BLENDER_TIME);
    	illum.setTargetA(255);

    	illum.gotoTarget();
    	illuOn = true;

	Layout cache = getContainer("Main").getLayout("normal");

	cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_i");
	cache.getObject("sidebarright").setXMLParam("image","sidebar.right_i");
    }

}

SeekerPos.onTimer()
{
	int l = getPlayItemLength();
	int p = getPosition() / l * 72;

	seeker_pos.setXMLParam("X",IntegerToString(28+p));
}

playButton.onLeftButtonDown(int x,int y)
{
        illuminator();
}

pauseButton.onLeftButtonDown(int x,int y)
{
        illuminator();
}

nextButton.onLeftButtonDown(int x,int y)
{
        illuminator();
}

prevButton.onLeftButtonDown(int x,int y)
{
        illuminator();
}

th_left.onLeftButtonDown(int x,int y)
{
        illuminator();
}

th_right.onLeftButtonDown(int x,int y)
{
        illuminator();
}

BackToPlay.onTimer()
{

	BackToPlay.stop();

	if (menustate != 1)
	{
		if (currentmenu != 31)
		{
		menustate = 1;
		// Back to info
		if (System.getPrivateString(CLOCK_CFG,"0") == "1") Clock.start();
		else TitleBar.setText("Playing");
		menugroup.setTargetX(X_HIDDEN_LEFT);
		menugroup.setTargetSpeed(HIDE_SPEED);
		thgroup.setTargetX(X_HIDDEN_LEFT);
		thgroup.setTargetSpeed(HIDE_SPEED);

		infogroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
		infogroup.setTargetX(X_VISIBLE);
		infogroup.setTargetSpeed(SHOW_SPEED);
		seekergroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
		seekergroup.setTargetX(X_VISIBLE-1);
		seekergroup.setTargetSpeed(SHOW_SPEED);

		menugroup.gotoTarget();

		if (CurrentMenu == 12) {
		thgroup.gotoTarget(); }

		infogroup.gotoTarget();
		seekergroup.gotoTarget();
		// Setting as off
		System.setPrivateInt("iPod-Menu","IsOn",0);
		}
	}
}

illuminator()
{
  Int c;
  c = System.getPrivateInt(BG_TIMER,1);


  if (c == 1)
  {
  	if ((force_illum == 1) && (Illuon == false))
  	{
  		IlluOn = true;

        Blender.stop();
        illum.setTargetSpeed(BLENDER_TIME);
        illum.setTargetA(255);

        illum.gotoTarget();

	Layout cache = getContainer("Main").getLayout("normal");

	cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_i");
	cache.getObject("sidebarright").setXMLParam("image","sidebar.right_i");
  	}
  	else if ((force_illum == 0) && (Illuon == true))
  	{
  		IlluOn = false;

        Blender.stop();
        illum.setTargetSpeed(BLENDER_TIME);
        illum.setTargetA(0);

        illum.gotoTarget();

        Layout cache = getContainer("Main").getLayout("normal");

        cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_");
        cache.getObject("sidebarright").setXMLParam("image","sidebar.right_");
  	}
  }
  else
  {
    IlluOn = true;

    Blender.stop();
    illum.setTargetSpeed(BLENDER_TIME);
    illum.setTargetA(255);

    illum.gotoTarget();

	Layout cache = getContainer("Main").getLayout("normal");

	cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_i");
	cache.getObject("sidebarright").setXMLParam("image","sidebar.right_i");

    if (c == 6)
    {
    }
    else
    {
      Blender.start();
    }
  }

  BackToPlay.start();
}

Blender.onTimer()
{
  Blender.stop();

  illum.setTargetSpeed(BLENDER_TIME);
  illum.setTargetA(0);

  illum.gotoTarget();
  illuOn = false;

	Layout cache = getContainer("Main").getLayout("normal");

	cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_");
	cache.getObject("sidebarright").setXMLParam("image","sidebar.right_");

}

illum.onTargetReached()
{
 	updateItemColor(currentItem,0);
}

System.onScriptUnloading()
{
	delete volMap;
	delete Clock;
	delete FlashSelected;
	delete Speed;
}

Illum_by_menu.onTimer()
{
	if (mouseonbutton == 1)
	{
			if (force_illum == 0)
			{
				force_illum = 1;
			}
			else
			{
				force_illum = 0;
			}
			skip_action = 1;
			illuminator();
	}
	Illum_by_menu.stop();
	volback.stop();
}

Volume.onLeftButtonDown(int x, int y)
{
	illuminator();
	// Checking if Wer'e using the menu
	mousedown = 1;

	x = x - Volume.getLeft();
	y = y - Volume.getTop();
	downvalue = volMap.getValue(x, y);

       if (menuMap.inRegion(x, y))
       {

       	mouseonbutton = 1;
       	Illum_by_menu.stop();
       	Illum_by_menu.start();
       }
       else if (nextMap.inRegion(x, y))
       {
       	mouseonbutton = 2;
       }
       else if (playMap.inRegion(x, y))
       {
       	mouseonbutton = 3;
       }
       else if (prevMap.inRegion(x, y))
       {
        mouseonbutton = 4;
       }

	If (menustate==1)
	{

	}
	else if (menustate==2)
	{
		// Getting current mouse location and setting as old using the map
		if (volMap.inRegion(x, y)) {
			OldValue = volMap.getValue(x, y);
    		}
		else {
			OldValue = -1;
		}
		SelectingItem = 1;
		Speed.start();
		SpeedInc = SPEED_MAX;
	}
}

Volume.onLeftButtonUp(int x, int y)
{
	mousedown = 0;

	int	nx = x - Volume.getLeft();
	int	ny = y - Volume.getTop();

	if ((volMap.getValue(nx, ny) - downvalue < VOL_SENSITIVITY) && (volMap.getValue(nx, ny) - downvalue > -VOL_SENSITIVITY))
	{
       if (menuMap.inRegion(nx, ny))
       {
       	if (mouseonbutton == 1)
       	{
       		if (skip_action == 0)
       		{
       			menubutton.leftclick();
       		}

       		skip_action = 0;
		}
       }
       else if (nextMap.inRegion(nx, ny))
       {
       	if (mouseonbutton == 2)
       	{
       		nextbutton.leftclick();

       	}
       }
       else if (playMap.inRegion(nx, ny))
       {
       	if (mouseonbutton == 3)
       	{
       		if (getstatus() == 1)
       		{
       			pausebutton.leftclick();
       		}
       		else
       		{
       			playbutton.leftclick();
       		}
       	}
       }
       else if (prevMap.inRegion(nx, ny))
       {
       	if (mouseonbutton == 4)
       	{
        	prevbutton.leftclick();
        }
       }
    }

    mouseonbutton = 0;

	If (menustate==1)
	{
		// Checking if the clock has to be shown
		Volback.start();
	}
	else if ((menustate==2)&& (SelectingItem))
	{

		// Checking if we are selecting item and checking
		// whether we need to change the selected item
		x = x - Volume.getLeft();
		y = y - Volume.getTop();

		if (volMap.inRegion(x, y)) {
			float v = volMap.getValue(x, y);
			// Checking if we have an old value
			if (OldValue != -1) {
				float Diff = OldValue - v;

				// Checking for positive end of map
				if (Diff < -200)
				{
					OldValue = OldValue + 255;
					Diff = OldValue - v;
				}
				// Checking for negative end of map
				else if (Diff > 200)
				{
					OldValue = OldValue - 255;
					Diff = OldValue - v;
				}

				// Checking diff for positive move
				if (Diff > MIN_DIFF_FOR_MOVE)
				{
					updateItem(1);
					OldValue = v;
				}
				// Checking diff for negative move
				else if (Diff < -MIN_DIFF_FOR_MOVE)
				{
					updateItem(0);
					OldValue = v;
				}
			}
		}
		// Stop selecting items
		SelectingItem = 0;
		Speed.stop();
	}
}

Volback.onTimer()
{

	if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
	{
		if (mouseonbutton != 1)
		{
            if (System.getPrivateString(CLOCK_CFG,"0") == "1") Clock.start();
            else TitleBar.setText("Playing");

            // Showing info window insted of volume

            if (Volchanging)
            {
                volgroup.setTargetX(X_HIDDEN_RIGHT);
                volgroup.setTargetSpeed(HIDE_SPEED);
                seekergroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
                seekergroup.setTargetX(X_VISIBLE-1);
                seekergroup.setTargetSpeed(SHOW_SPEED);

                seekergroup.gotoTarget();
                volgroup.gotoTarget();
            }

            Volchanging = 0;
        }
	}
	Volback.stop();
}

System.onVolumeChanged(int v)
{
	volback.stop();
}

Volume.onMouseMove(int x, int y)
{
	// Checking if selecting item

	BackToPlay.stop();
	BackToPlay.start();

    int nx = x - Volume.getLeft();
    int ny = y - Volume.getTop();

	if  (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
	{
		if  (System.getPrivateInt("Seeking","IsOn",0) == 0)
		{
		    if (Volchanging == 0)
            {
                if (mousedown == 1)
                {
                	if ((volMap.getValue(nx, ny) - downvalue > VOL_SENSITIVITY) || (volMap.getValue(nx, ny) - downvalue < -VOL_SENSITIVITY))
                	{

                        mouseonbutton = 0;

                        // Showing the volume group
                        Clock.Stop();

                        volgroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
                        volgroup.setTargetX(X_VISIBLE);
                        volgroup.setTargetSpeed(SHOW_SPEED);
                        seekergroup.setTargetX(X_HIDDEN_LEFT);
                        seekergroup.setTargetSpeed(HIDE_SPEED);

                        seekergroup.gotoTarget();
                        volgroup.gotoTarget();

                        Volchanging = 1;

                        Volback.stop();
					}
                }
            }
        }
        else
        {
        	    Seekerback.stop();
    			Seekerback.start();
        }
    }

	if ((volMap.getValue(nx, ny) - downvalue > VOL_SENSITIVITY) || (volMap.getValue(nx, ny) - downvalue < -VOL_SENSITIVITY))
	{
		mouseonbutton = 0;
	}

	if ((menustate != 1) && (SelectingItem))
	{
		x = x - Volume.getLeft();
		y = y - Volume.getTop();

		// Checking if we are whithin the map
		if (volMap.inRegion(x, y)) {

			// Checking current value
			float v = volMap.getValue(x, y);

			// Checking old value
			if (OldValue != -1) {

				// Getting diff
				float Diff = OldValue - v;

				// Checking for positive end of map
				if (Diff < -200)
				{
					OldValue = OldValue + 255;
					Diff = OldValue - v;
				}
				// Checking for negative end of map
				else if (Diff > 200)
				{
					OldValue = OldValue - 255;
					Diff = OldValue - v;
				}

				// Checking diff for positive move
				if (Diff > MIN_DIFF_FOR_MOVE)
				{
					updateItem(1);
					OldValue = v;
				}
				// Checking diff for negative move
				else if (Diff < -MIN_DIFF_FOR_MOVE)
				{
					updateItem(0);
					OldValue = v;
				}
			}
			else
			{
				OldValue = v;
			}
		}
		else
		{
			OldValue = -1;
		}
	}
}

menubutton.OnLeftButtonDown(int x, int y)
{
        illuminator();
}

menubutton.OnLeftClick()
{
        illuminator();
	// Checking if we are in the info "menu"

	If (menustate == 1)
	{

		// Showing menu
		menustate = 2;

		Clock.stop();

		TEXT temp = menugroup.getObject("Line1");

		if (temp.getText() == "Playlists") {
		TitleBar.setText("iPod"); }
		else if (temp.getText() == "Equalizer") {
		TitleBar.setText("Extras"); }
		else if (strleft(temp.getText(),4) == "Acti") {
		TitleBar.setText("Equalizer"); }
		else if (strleft(temp.getText(),4) == "Repe") {
		TitleBar.setText("Settings"); }
		else if (temp.getText() == "Off") {
		TitleBar.setText("Backlight"); }
		else {
		TitleBar.setText("Custom"); }

		if (CurrentMenu == 12) {
		TitleBar.setText("Thinger"); }

		infogroup.setTargetX(X_HIDDEN_RIGHT);
		infogroup.setTargetSpeed(HIDE_SPEED);

		if(CurrentMenu == 12){
		thgroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
		thgroup.setTargetX(X_VISIBLE);
		thgroup.setTargetSpeed(SHOW_SPEED);
		thgroup.gotoTarget();	}
		else {
		menugroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
		menugroup.setTargetX(X_VISIBLE);
		menugroup.setTargetSpeed(SHOW_SPEED); }

		ResetItems(0);

		infogroup.gotoTarget();
		menugroup.gotoTarget();

		if (System.getPrivateInt("Seeking","IsOn",0) == 1)
		{
			seekergroup2.setTargetX(X_HIDDEN_RIGHT);
			seekergroup2.setTargetSpeed(HIDE_SPEED);
			seekergroup2.gotoTarget();
		}
		else if (Volchanging)
		{
			volgroup.setTargetX(X_HIDDEN_RIGHT);
			volgroup.setTargetSpeed(HIDE_SPEED);
			volgroup.gototarget();
			Volchanging = 0;
		}
		else
		{
			seekergroup.setTargetX(X_HIDDEN_RIGHT);
			seekergroup.setTargetSpeed(HIDE_SPEED);
			seekergroup.gotoTarget();
		}

		seekerback.stop();
		System.setPrivateInt("Seeking","IsOn",0);
		System.setPrivateInt("iPod-Menu","IsOn",1);

		// Setting as on

	}
	// Checkin for actual menu
	else if (menustate == 2)
	{
		// Main menu
		if (CurrentMenu == 0)
		{
			//menustate = 1;
			// Back to info
			//if (System.getPrivateString(CLOCK_CFG,"0") == "1") Clock.start();
			//else TitleBar.setText("Playing");
			//menugroup.setTargetX(X_HIDDEN_RIGHT);
			//menugroup.setTargetSpeed(HIDE_SPEED);

			//infogroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
			//infogroup.setTargetX(X_VISIBLE);
			//infogroup.setTargetSpeed(SHOW_SPEED);

			//menugroup.gotoTarget();
			//infogroup.gotoTarget();
			// Setting as off
			//System.setPrivateInt("iPod-Menu","IsOn",0);
		}
		else if (CurrentMenu == 11)
		{
			// Back to extras from equalizer
			CurrentMenu = 3;
			MenuMax = 3;
			SwitchMenu(2,1);
		}
		else if (CurrentMenu == 31)
		{
			// Back to extras from clock
			CurrentMenu = 3;
			MenuMax = 3;
			SwitchMenu(2,1);
			Clock2.stop();
		}
		else if (CurrentMenu == 41)
		{
			// Back to settings from backlighttimer
			CurrentMenu = 1;
			MenuMax = 6;
			SwitchMenu(1,1);
		}
		else if (CurrentMenu == 42)
		{
			// Back to settings from sleeptimer
			CurrentMenu = 1;
			MenuMax = 6;
			SwitchMenu(1,1);
		}
		else if (CurrentMenu == 12)
		{

			// From thinger back to extras
			MenuMax = 3;
			CurrentMenu = 2;
			TitleBar.setText("Extras");
			thgroup.setTargetX(X_HIDDEN_RIGHT);
			thgroup.setTargetSpeed(HIDE_SPEED);

			menugroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
			menugroup.setTargetX(X_VISIBLE+1);
			menugroup.setTargetSpeed(SHOW_SPEED);

			ResetItems(0);

			thgroup.gotoTarget();
			menugroup.gotoTarget();
		}
		else if (CurrentMenu == 111)
		{
			// From equalizer custom to equalizer
			SwitchMenu(11,1);

		    menugroup2.getObject("scrollframe").hide();
            menugroup2.getObject("scrollbar").hide();

            menugroup2.getObject("Line1").setXmlParam("w","83");
            menugroup2.getObject("Line2").setXmlParam("w","83");
            menugroup2.getObject("Line3").setXmlParam("w","83");
            menugroup2.getObject("Line4").setXmlParam("w","83");
            menugroup2.getObject("Line5").setXmlParam("w","83");
            menugroup2.getObject("Line6").setXmlParam("w","83");
            menugroup2.getObject("LineBar").setXmlParam("w","83");
		}
		else
		{
			// Back to main menu
			CurrentMenu = 0;
			menugroup2.getObject("BigText").setXMLParam("x","-124");
			SwitchMenu(0,1);
		}
	}
	EditingItem = false;
	StopFlashing();
}


updateItem(Boolean Negative)
{
	if (!EditingItem)
	{

		// Changing selection
		Layer OldBar = menugroup.getObject("LineBar");
		int OldItem = CurrentItem;
		// Checking if menu is bigger than 5
		if (CurrentMenu == 111) UpdateBigMenu(Negative);

		// Updating current item
		if (!Negative)
		{
			CurrentItem = CurrentItem + 1;
			if (CurrentItem > MenuMax) CurrentItem = CurrentItem-1;
		}
		else
		{
			CurrentItem = CurrentItem - 1;
			if (CurrentItem < 1) CurrentItem = CurrentItem+1;
		}
		// Updating display
		OldBar.setXmlParam("y",System.integerToString(24 + ((CurrentItem - 1) * 10)));
		menugroup.getObject("Line" + System.integerToString(OldItem)).setXmlParam("color","40,40,40");
		menugroup.getObject("Line" + System.integerToString(OldItem) + "Arrow").setXmlParam("image","itemarrow");
		updateItemColor(CurrentItem,0);
	}
	// Handling a comlex menu
	else if (CurrentMenu == 111)
	{

		// Changing eq values
		int BandNum = CurrMenuMin + CurrentItem - 2;
		int BandVal = System.getEqBand(BandNum);
		if (Negative)
		{
			BandVal = BandVal - SpeedInc;
			if (BandVal < -127) BandVal = -127;
		}
		else
		{
			BandVal = BandVal + SpeedInc;
			if (BandVal > 127) BandVal = 127;
		}
		System.setEqBand(BandNum,BandVal);
		String CurrentState = System.integertostring(BandVal);
		menugroup.getObject("Line" + System.integerToString(CurrentItem)).setXmlParam("default",GetEqBandName(CurrMenuMin + CurrentItem - 2) + CurrentState);
		SpeedInc = SPEED_MAX;
		Speed.start();
	}
	else if (CurrentMenu == 11)
	{

		// Changing preamp values
		int PreVal = System.getEqPreAmp();
		if (Negative)
		{
			PreVal = PreVal - SpeedInc;
			if (PreVal < -127) PreVal = -127;
		}
		else
		{
			PreVal = PreVal + SpeedInc;
			if (PreVal > 127) PreVal = 127;
		}
		System.setEqPreAmp(PreVal);
		SpeedInc = SPEED_MAX;
		Speed.start();
	}
}

SelectButton.onLeftButtonDown(int x, int y)
{
        illuminator();
}

Seekerback.onTimer()
{
	if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
	{
                seekergroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
                seekergroup.setTargetX(X_VISIBLE);
                seekergroup.setTargetSpeed(SHOW_SPEED);
                seekergroup2.setTargetX(X_HIDDEN_RIGHT);
                seekergroup2.setTargetSpeed(HIDE_SPEED);

                seekergroup.gototarget();
                seekergroup2.gototarget();

     }

     System.setPrivateInt("Seeking","IsOn",0);

     Seekerback.stop();
     SeekerPos.stop();
}

System.onStop()
{
                    seekergroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
                    seekergroup.setTargetX(X_VISIBLE);
                    seekergroup.setTargetSpeed(SHOW_SPEED);
                    seekergroup2.setTargetX(X_HIDDEN_RIGHT);
                    seekergroup2.setTargetSpeed(HIDE_SPEED);

                    seekergroup.gototarget();
                    seekergroup2.gototarget();

                    System.setPrivateInt("Seeking","IsOn",0);
                    Seekerback.stop();
                    SeekerPos.stop();
}

SleepTimer.onTimer()
{
	if (sleep_state != 0)
	{
		if (steps_left > 0)
		{
			steps_left = steps_left-1;
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));
		}
		else
		{
			sleeptimer.stop();
			saveVol = getVolume();
			VolDownTimer.start();
		}
	}
}

VolDownTimer.onTimer()
{
	int v = getvolume();

	if (v <= 10)
	{
		voldowntimer.stop();
		stop();
		setVolume(saveVol);
		bat.leftclick();

	}
	else
	{
		setVolume(v-10);
	}
}

SelectButton.onLeftClick()
{
	Text TitleBar = getContainer("Main").getLayout("normal").getObject("ipodheadline");
	String CurrentState;
	Button CurrentButton;
	int updateitemindex = -1;

	if (menustate == 1)
	{
		if ((getstatus() != 0) && (Volchanging == 0))
  		{
		    if (System.getPrivateInt("Seeking","IsOn",0) == 0)
            {
                    seekergroup2.setXmlParam("x",X_HIDDEN_RIGHT_STR);
                    seekergroup2.setTargetX(X_VISIBLE);
                    seekergroup2.setTargetSpeed(SHOW_SPEED);
                    seekergroup.setTargetX(X_HIDDEN_LEFT);
                    seekergroup.setTargetSpeed(HIDE_SPEED);

                    seekergroup.gototarget();
                    seekergroup2.gototarget();

                    System.setPrivateInt("Seeking","IsOn",1);
                    Seekerback.stop();
                    Seekerback.start();
                    SeekerPos.start();
            }
            else
            {
                    seekergroup.setXmlParam("x",X_HIDDEN_LEFT_STR);
                    seekergroup.setTargetX(X_VISIBLE);
                    seekergroup.setTargetSpeed(SHOW_SPEED);
                    seekergroup2.setTargetX(X_HIDDEN_RIGHT);
                    seekergroup2.setTargetSpeed(HIDE_SPEED);

                    seekergroup.gototarget();
                    seekergroup2.gototarget();

                    System.setPrivateInt("Seeking","IsOn",0);
                    Seekerback.stop();
                    SeekerPos.stop();
            }
        }

        if (Volchanging)
        {
        	volback.ontimer();
        }
 }
	else if ((CurrentMenu == 0) && (menustate == 2))
	{

		// Activating the correct options
		if (CurrentItem == 1)
		{
			System.getContainer("Pledit").toggle();
		}
		else if (CurrentItem == 2)
		{
			System.Eject();
		}
		else if (CurrentItem == 3)
		{
			SwitchMenu(2,0);
		}
		else if (CurrentItem == 4)
		{
			SwitchMenu(1,0);
		}
		else if (CurrentItem == 5)
		{
			if (force_illum == 0)
			{
				force_illum = 1;
			}
			else
			{
				force_illum = 0;
			}
			///////////////////////////////////////////////////
		}
		else if (CurrentItem == 6)
		{
			menustate = 1;
			// Back to info
			if (System.getPrivateString(CLOCK_CFG,"0") == "1") Clock.start();
			else TitleBar.setText("Playing");
			menugroup.setTargetX(X_HIDDEN_LEFT);
			menugroup.setTargetSpeed(HIDE_SPEED);

			infogroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
			infogroup.setTargetX(X_VISIBLE);
			infogroup.setTargetSpeed(SHOW_SPEED);
			seekergroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
			seekergroup.setTargetX(X_VISIBLE-1);
			seekergroup.setTargetSpeed(SHOW_SPEED);


			menugroup.gotoTarget();
			infogroup.gotoTarget();
			seekergroup.gotoTarget();
			// Setting as off
			System.setPrivateInt("iPod-Menu","IsOn",0);
		}
	}
	else if ((CurrentMenu == 1) && (menustate == 2))
	{
		// Activating the correct options and updating items
		if (CurrentItem == 1)
		{
			Repeat_Mode.setData(System.integerToString(!System.stringToInteger(Repeat_Mode.getData())));
			if (Repeat_Mode.getData() == "1") CurrentState = "On";
			else CurrentState = "Off";
			menugroup.getObject("Line1").setXmlParam("default","Repeat\t" + CurrentState);
		}
		else if (CurrentItem == 2)
		{
			Shuffle_Mode.setData(System.integerToString(!System.stringToInteger(Shuffle_Mode.getData())));
			if (Shuffle_Mode.getData() == "1") CurrentState = "On";
			else CurrentState = "Off";
			menugroup.getObject("Line2").setXmlParam("default","Shuffle\t" + CurrentState);
		}
		else if (CurrentItem == 3)
		{
			CrossFade_Mode.setData(System.integerToString(!System.stringToInteger(CrossFade_Mode.getData())));
			if (CrossFade_Mode.getData() == "1") CurrentState = "On";
			else CurrentState = "Off";
			menugroup.getObject("Line3").setXmlParam("default","X Fade\t" + CurrentState);
		}
		else if (CurrentItem == 4)
		{
			if (System.getPrivateString(CLOCK_CFG,"0") == "1")
			{
				System.setPrivateString(CLOCK_CFG,"0");
				CurrentState = "Off";
			}
			else
			{
				System.setPrivateString(CLOCK_CFG,"1");
				CurrentState = "On";
			}
			menugroup.getObject("Line4").setXmlParam("default","Clock\t" + CurrentState);
		}
		else if (CurrentItem == 5)
		{
			SwitchMenu(41,0);
		}
 		else if (CurrentItem == 6)
		{
			SwitchMenu(42,0);
		}
	}
	else if (CurrentMenu == 41)
	{
		if (CurrentItem == 1)
		{
  			Blender.stop();

  			illum.setTargetSpeed(BLENDER_TIME);
  			illum.setTargetA(0);

  			illum.gotoTarget();

            Layout cache = getContainer("Main").getLayout("normal");

            cache.getObject("sidebarleft").setXMLParam("image","sidebar.left_");
            cache.getObject("sidebarright").setXMLParam("image","sidebar.right_");

  			illuOn = false;
		}

  		if (CurrentItem == 1)
  		{
    		Blender.setDelay(1000);
    		updateitemindex = 1;
  		}
 		else if (CurrentItem == 2)
  		{
    		Blender.setDelay(1000);
    		updateitemindex = 2;
  		}
  		else if (CurrentItem == 3)
  		{
    		Blender.setDelay(2000);
    		updateitemindex = 3;
  		}
  		else if (CurrentItem == 4)
  		{
    		Blender.setDelay(5000);
    		updateitemindex = 4;
  		}
  	    else if (CurrentItem == 5)
        {
    		Blender.setDelay(10000);
    		updateitemindex = 5;
  		}

		System.setPrivateInt(BG_TIMER,CurrentItem);
		CurrentMenu = 1;
		//MenuMax = 5;
		SwitchMenu(1,1);
	}
	else if (CurrentMenu == 42)
	{
		SleepTimer.stop();

		if (CurrentItem == 1)
		{
			Sleep_state = 0;
			steps_left = 0;
			Sleep_clock.setXMLParam("visible","0");
			Sleep_Left.setXMLParam("visible","0");
		}
		else if (CurrentItem == 2)
		{
			steps_left = 15;

			Sleep_clock.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));

			SleepTimer.start();
			Sleep_state = 1;
		}
		else if (CurrentItem == 3)
		{
			steps_left = 30;

			Sleep_clock.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));

			SleepTimer.start();
			Sleep_state = 2;
		}
		else if (CurrentItem == 4)
		{
			steps_left = 60;

			Sleep_clock.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));

			SleepTimer.start();
			Sleep_state = 3;
		}
		else if (CurrentItem == 5)
		{
			steps_left = 90;

			Sleep_clock.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));

			SleepTimer.start();
			Sleep_state = 4;
		}
		else if (CurrentItem == 6)
		{
			steps_left = 120;

			Sleep_clock.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("visible","1");
			Sleep_Left.setXMLParam("default",IntegerToString(steps_left));

			SleepTimer.start();
			Sleep_state = 5;
		}

		SwitchMenu(1,1);
	}
	else if ((CurrentMenu == 2) && (menustate == 2))
	{
		menugroup2.getObject("BigText").setXMLParam("x","-124");

		// Activating the correct options
		if (CurrentItem == 1)
		{
			SwitchMenu(11,0);
		}
		else if (CurrentItem == 2)
		{

			CurrentMenu = 12;
    		TitleBar.setText("Thinger");
			menugroup.setTargetX(X_HIDDEN_LEFT);
			menugroup.setTargetSpeed(HIDE_SPEED);

			thgroup.setXmlParam("x",X_HIDDEN_RIGHT_STR);
			thgroup.setTargetX(X_VISIBLE);
			thgroup.setTargetSpeed(SHOW_SPEED);

			menugroup.gotoTarget();
			thgroup.gotoTarget();
		}
		else if (CurrentItem == 3)
		{
			Int SecondsTime = System.getTimeOfDay();
			menugroup.getObject("BigText").setXMLPAram("default",System.integerToLongTime(SecondsTime));
			menugroup2.getObject("BigText").setXMLPAram("default",System.integerToLongTime(SecondsTime));

			Clock2.start();
    		TitleBar.setText("Clock");
			MenuMax = 0;
			switchMenu(31,0);
		}
	}
	else if ((CurrentMenu == 11) && (!EditingItem) && (menustate == 2))
	{
		// Activating the correct options and updating items
		if (CurrentItem == 1)
		{
			if (System.getEq() == true)
			{
				System.setEq(false);
				CurrentState = "Off";
			}
			else
			{
				System.setEq(true);
				CurrentState = "On";
			}
			menugroup.getObject("Line1").setXmlParam("default","Active\t" + CurrentState);
		}
		else if (CurrentItem == 2)
		{
			SwitchMenu(111,0);
			menugroup.getObject("scrollbar").setXMLParam("Y","25");
		}
		else if (CurrentItem == 3)
		{
			CurrentButton = eqgroup.getObject("eqpresets");
			CurrentButton.leftClick();
		}
		else if (CurrentItem == 4)
		{
			FlashSelected.start();
			EditingItem = true;
		}
	}
	else if ((CurrentMenu == 111) || ((CurrentMenu == 11) && EditingItem) && (menustate==2))
	{
		// Checking for edit
		if (EditingItem)
		{
			StopFlashing();
		}
		else
		{
			FlashSelected.start();
		}
		EditingItem = !EditingItem;
	}

    illuminator();

    if (updateitemindex != -1)
    {
    	updateitemcolor(updateitemindex,1);
    }
}

SwitchMenu(Int DestMenu, Boolean Reverse)
{
	int CurrentLine;
	String CurrentState;
	CurrMenuMin = 1;
	CurrMenuMax = 6;

	// Resetting menu
	for (CurrentLine = 1;CurrentLine <=6;++CurrentLine)
	{
		menugroup2.getObject("Line" + System.integerToString(CurrentLine)).setXmlParam("default","");
		menugroup2.getObject("Line" + System.integerToString(CurrentLine) + "Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
	}

	// Checing menu and putting values accordingly
	if (DestMenu == 0)
	{
		MenuMax = 6;
		TitleBar.setText("iPod");

		menugroup2.getObject("Line1").setXmlParam("default","Playlists");

		menugroup2.getObject("Line2").setXmlParam("default","Browse");

		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","Extras");

		menugroup2.getObject("Line4Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line4").setXmlParam("default","Settings");

		menugroup2.getObject("Line5").setXmlParam("default","Backlight");

		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line6").setXmlParam("default","Now Playing");

	}
	else if (DestMenu == 1)
	{
		MenuMax = 6;
		TitleBar.setText("Settings");
		System.integerToString(!System.stringToInteger(Repeat_Mode.getData()));
		if (Repeat_Mode.getData() == "1") CurrentState = "On"; //1
		else CurrentState = "Off";
		menugroup2.getObject("Line1").setXmlParam("default","Repeat\t" + CurrentState);
		System.integerToString(!System.stringToInteger(Shuffle_Mode.getData()));
		if (Shuffle_Mode.getData() == "1") CurrentState = "On"; //2
		else CurrentState = "Off";
		menugroup2.getObject("Line2").setXmlParam("default","Shuffle\t" + CurrentState);
		System.integerToString(!System.stringToInteger(CrossFade_Mode.getData()));
		if (CrossFade_Mode.getData() == "1") CurrentState = "On"; //3
		else CurrentState = "Off";
		menugroup2.getObject("Line3").setXmlParam("default","X Fade\t" + CurrentState);
		if (System.getPrivateString(CLOCK_CFG,"0") == "1") CurrentState = "On"; //2
		else CurrentState = "Off";
		menugroup2.getObject("Line4").setXmlParam("default","Clock\t" + CurrentState);

		menugroup2.getObject("Line5").setXmlParam("default","Backlight Timer");
		menugroup2.getObject("Line5Arrow").setXmlParam("x",AROW_VISIBLE_LOC);

		menugroup2.getObject("Line6").setXmlParam("default","Sleep Timer");
		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
	}
	else if (DestMenu == 2)
	{
		MenuMax = 3;
		TitleBar.setText("Extras");
		menugroup2.getObject("Line1Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line1").setXmlParam("default","Equalizer");
		menugroup2.getObject("Line2Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line2").setXmlParam("default","Thinger");
		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","Clock");

		if (Reverse)
		{
			menugroup2.getObject("Line6").setXmlParam("default","");
		}

		menugroup2.getObject("Line6").setXmlParam("default","");
		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);

	}
	else if (DestMenu == 31)
	{
		MenuMax = 0;

		menugroup2.getObject("Line1").setXmlParam("default","");
		menugroup2.getObject("Line1Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line2").setXmlParam("default","");
		menugroup2.getObject("Line2Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","");
		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line4").setXmlParam("default","");
		menugroup2.getObject("Line4Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line5").setXmlParam("default","");
		menugroup2.getObject("Line5Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line6").setXmlParam("default","");
		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);

		menugroup2.getObject("BigText").setXMLParam("x","24");
	}
	else if (DestMenu == 41)
	{
		MenuMax = 6;
		TitleBar.setText("Backlight");

		menugroup2.getObject("Line1").setXmlParam("default","Off");
		menugroup2.getObject("Line1Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line2").setXmlParam("default","1 Second");
		menugroup2.getObject("Line2Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","2 Seconds");
		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line4").setXmlParam("default","5 Seconds");
		menugroup2.getObject("Line4Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line5").setXmlParam("default","10 Seconds");
		menugroup2.getObject("Line5Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line6").setXmlParam("default","Allways on");
		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
	}
	else if (DestMenu == 42)
	{
		MenuMax = 6;
		TitleBar.setText("Sleep");

		menugroup2.getObject("Line1").setXmlParam("default","Off");
		menugroup2.getObject("Line1Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line2").setXmlParam("default","15 Minutes");
		menugroup2.getObject("Line2Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","30 Minutes");
		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line4").setXmlParam("default","60 Minutes");
		menugroup2.getObject("Line4Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line5").setXmlParam("default","90 Minutes");
		menugroup2.getObject("Line5Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
		menugroup2.getObject("Line6").setXmlParam("default","120 Minutes");
		menugroup2.getObject("Line6Arrow").setXmlParam("x",AROW_INVISIBLE_LOC);
	}
	else if (DestMenu == 11)
	{
		MenuMax = 4;
		TitleBar.setText("Equalizer");
		if (System.getEq() == true) CurrentState = "On";
		else CurrentState = "Off";
		menugroup2.getObject("Line1").setXmlParam("default","Active\t" + CurrentState);
		menugroup2.getObject("Line2Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line2").setXmlParam("default","Custom");
		menugroup2.getObject("Line3Arrow").setXmlParam("x",AROW_VISIBLE_LOC);
		menugroup2.getObject("Line3").setXmlParam("default","Presets");
		menugroup2.getObject("Line4").setXmlParam("default","Preamp\t" + System.integerToString(System.getEqPreamp()));
	}
	else if (DestMenu == 111)
	{
		menugroup2.getObject("scrollframe").show();
		menugroup2.getObject("scrollbar").show();

		menugroup2.getObject("Line1").setXmlParam("w","77");
		menugroup2.getObject("Line2").setXmlParam("w","77");
		menugroup2.getObject("Line3").setXmlParam("w","77");
		menugroup2.getObject("Line4").setXmlParam("w","77");
		menugroup2.getObject("Line5").setXmlParam("w","77");
		menugroup2.getObject("Line6").setXmlParam("w","77");
		menugroup2.getObject("LineBar").setXmlParam("w","77");

		MenuMax = 6;
		TitleBar.setText("Custom");

		// Going over items
		for (int UpdateCount = 1;UpdateCount <= 6;++UpdateCount)
		{
			// Setting band info
			CurrentState = System.integertostring(System.getEqBand(CurrMenuMin +UpdateCount - 2));
			menugroup2.getObject("Line" + System.integerToString(UpdateCount)).setXmlParam("default",GetEqBandName(CurrMenuMin +UpdateCount - 2) + CurrentState);
		}
	}
	CurrentMenu = DestMenu;

	// Checking direction of switch
	if (Reverse)
	{
		menugroup2.setXmlParam("x",X_HIDDEN_LEFT_STR);
		menugroup.setTargetX(X_HIDDEN_RIGHT);
	}
	else
	{
		menugroup2.setXmlParam("x",X_HIDDEN_RIGHT_STR);
		menugroup.setTargetX(X_HIDDEN_LEFT);
	}

	// Replacing the menu

	if ((DestMenu == 2) && (Reverse == 1))
	{
		menugroup2.setTargetX(X_VISIBLE+1);
	}
	else if ((DestMenu == 1) && (Reverse == 1))
	{
		menugroup2.setTargetX(X_VISIBLE+1);
	}
	else if ((DestMenu == 11) && (Reverse == 0))
	{
		menugroup2.setTargetX(X_VISIBLE-1);
	}
	else
	{
		menugroup2.setTargetX(X_VISIBLE);
	}

	Group tempmenu = menugroup;
      	menugroup = menugroup2;
	menugroup2 = tempmenu;
	menugroup.setTargetSpeed(SHOW_SPEED);
	menugroup2.setTargetSpeed(HIDE_SPEED);
	ResetItems(DestMenu);
	menugroup.gotoTarget();
	menugroup2.gotoTarget();
}

ResetItems(Int d)
{
	Layer OldBar = menugroup.getObject("LineBar");

	if (d == 41)
	{
		Int c = System.getPrivateInt(BG_TIMER,1);
		OldBar.setXmlParam("y",System.integerToString(24 + ((c - 1) * 10)));

		for (int OtherItems = 1;OtherItems <= 6;++OtherItems)
		{
			// Setting others as normal
  			menugroup.getObject("Line" + System.integerToString(OtherItems)).setXmlParam("color","40,40,40");
			menugroup.getObject("Line" + System.integerToString(OtherItems) + "Arrow").setXmlParam("image","itemarrow");
		}

		// Setting first as selected
  		menugroup.getObject("Line" + integertostring(c)).setXmlParam("color","194,191,176");
  		menugroup.getObject("Line" + integertostring(c) + "Arrow").setXmlParam("image","itemarrow.selected");

		CurrentItem = c;
	}
	else if (d == 42)
	{
		Int c = Sleep_state+1;
		OldBar.setXmlParam("y",System.integerToString(24 + ((c - 1) * 10)));

		for (int OtherItems = 1;OtherItems <= 6;++OtherItems)
		{
			// Setting others as normal
  			menugroup.getObject("Line" + System.integerToString(OtherItems)).setXmlParam("color","40,40,40");
			menugroup.getObject("Line" + System.integerToString(OtherItems) + "Arrow").setXmlParam("image","itemarrow");
		}

		// Setting first as selected
  		menugroup.getObject("Line" + integertostring(c)).setXmlParam("color","194,191,176");
  		menugroup.getObject("Line" + integertostring(c) + "Arrow").setXmlParam("image","itemarrow.selected");

		CurrentItem = c;
	}
	else if (d == 31)
	{
		OldBar.setXmlParam("y","-125");
	}
	else
	{
		OldBar.setXmlParam("y","24");

		// Setting first as selected
		updateItemColor(1,0);
  		menugroup.getObject("Line1Arrow").setXmlParam("image","itemarrow.selected");

		for (int OtherItems = 2;OtherItems <= 6;++OtherItems)
		{
			// Setting others as normal
  			menugroup.getObject("Line" + System.integerToString(OtherItems)).setXmlParam("color","40,40,40");
			menugroup.getObject("Line" + System.integerToString(OtherItems) + "Arrow").setXmlParam("image","itemarrow");
		}
		CurrentItem = 1;
	}
}

Clock2.onTimer()
{
	Int SecondsTime = System.getTimeOfDay();
	menugroup.getObject("BigText").setXMLPAram("default",System.integerToLongTime(SecondsTime));
}

Clock.onTimer()
{
	Int SecondsTime = System.getTimeOfDay();
	TitleBar.setText(System.integerToLongTime(SecondsTime));
}

UpdateBigMenu(Boolean Reverse)
{
	String CurrentState;
	// Checking for the right menu
	int xd = 0;
	if (CurrentMenu == 111)
	{
		// Going up normally
		if ((Reverse) && (CurrentItem == 1) && (CurrMenuMin > 1))
		{
			CurrMenuMin = CurrMenuMin - 1;
			CurrMenuMax = CurrMenuMax - 1;
			CurrentItem = CurrentItem + 1;
		}
		// Going over the top (starting again from the buttom)
		else if ((Reverse) && (CurrMenuMin <= 1) && (CurrentItem == 1))
		{
			//CurrMenuMin = 5;
			//CurrMenuMax = 9;
		}
		// Going down normally
		else if ((!Reverse) && (CurrentItem == MenuMax) && (CurrMenuMin <= MenuMax))
		{
			if (CurrMenuMin <= 4)
			{
				CurrMenuMin = CurrMenuMin + 1;
				CurrMenuMax = CurrMenuMax + 1;
			}
			CurrentItem = CurrentItem - 1;
		}
		// Going over the bottom (atarting from the top
		else if ((!Reverse) && (CurrentItem == MenuMax) && (CurrMenuMin > MenuMax))
		{
			//CurrMenuMin = 1;
			//CurrMenuMax = 6;
		}

		for (int UpdateCount = 1;UpdateCount <= 6;++UpdateCount)
		{

			// Updating the EQ info
			CurrentState = System.integertostring(System.getEqBand(CurrMenuMin +UpdateCount - 2));
			menugroup.getObject("Line" + System.integerToString(UpdateCount)).setXmlParam("default",GetEqBandName(CurrMenuMin +UpdateCount - 2) + CurrentState);
		}

		xd = stringtointeger(getToken("0,9,18,26,35", ",", CurrMenuMin-1));
	}

	menugroup.getObject("scrollbar").setXMLPARAM("Y",integertostring(25+xd));
}

FlashSelected.onTimer()
{
	Layer OldBar = menugroup.getObject("LineBar");
	// Checking for flash mode
	if (FlashOn)
	{
		// Flash off
		OldBar.hide();
		menugroup.getObject("Line" + System.integerToString(CurrentItem)).setXmlParam("color","40,40,40");
		menugroup.getObject("Line" + System.integerToString(CurrentItem) + "Arrow").setXmlParam("image","itemarrow");
	}
	else
	{
		// Flash on
		OldBar.show();
		updateItemColor(CurrentItem,0);
	}
	// Switching mode
	FlashOn = !FlashOn;

        illuminator();
}

StopFlashing()
{

	// Reseting flash
	Layer OldBar = menugroup.getObject("LineBar");
	Layer OldBar2 = menugroup2.getObject("LineBar");
	FlashSelected.stop();
	OldBar.show();
	OldBar2.show();
	updateItemColor(CurrentItem,0);
	FlashOn = true;
}

updateItemColor(Int e, int f)
{
	if (f==0)
	{
        if (illuOn == true)
        {
            menugroup.getObject("Line" + System.integerToString(e)).setXmlParam("color",TXT_COLOR_BLUE);
            menugroup.getObject("Line" + System.integerToString(e) + "Arrow").setXmlParam("image","itemarrow.selected.blue");
        }
        else
        {
            menugroup.getObject("Line" + System.integerToString(e)).setXmlParam("color",TXT_COLOR_GREEN);
            menugroup.getObject("Line" + System.integerToString(e) + "Arrow").setXmlParam("image","itemarrow.selected");
        }
    }
    else
    {
        if (illuOn == true)
        {
            menugroup2.getObject("Line" + System.integerToString(e)).setXmlParam("color",TXT_COLOR_BLUE);
            menugroup2.getObject("Line" + System.integerToString(e) + "Arrow").setXmlParam("image","itemarrow.selected.blue");
        }
        else
        {
            menugroup2.getObject("Line" + System.integerToString(e)).setXmlParam("color",TXT_COLOR_GREEN);
            menugroup2.getObject("Line" + System.integerToString(e) + "Arrow").setXmlParam("image","itemarrow.selected");
        }
    }
}

Speed.onTimer()
{
	SpeedInc = SpeedInc SPEED_FORMULA;
	// Checking for minimum inc
	if (SpeedInc < 1)
	{
		SpeedInc = 1;
		stop();
	}
}

// Set the preamp on change (the presets change it as well)
System.onEqPreampChanged(int newvalue)
{
	// Checking if we're in the equalizer menu
	if (CurrentMenu == 11)
	{
		menugroup.getObject("Line4").setXmlParam("default","Preamp\t" + integerToString(newvalue));
	}
}

// Convert Band index to names in the menu
String GetEqBandName(Int BandNum)
{
	String ReturnValue = "???";
	if (BandNum == 0) ReturnValue = "60Hz";
	else if (BandNum == 1) ReturnValue = "170Hz";
	else if (BandNum == 2) ReturnValue = "310Hz";
	else if (BandNum == 3) ReturnValue = "600Hz";
	else if (BandNum == 4) ReturnValue = "1kHz";
	else if (BandNum == 5) ReturnValue = "3kHz";
	else if (BandNum == 6) ReturnValue = "6kHz";
	else if (BandNum == 7) ReturnValue = "12kHz";
	else if (BandNum == 8) ReturnValue = "14kHz";
	else if (BandNum == 9) ReturnValue = "16kHz";

	return (ReturnValue + "\t");
}