#include "../../../lib/std.mi"
#include "../../../lib/pldir.mi"

Function updatedisplay();

Global layout mainnormal;
Global button play, pause, next, prev, stop, playstatus;
Global Group infogroup, seekergroup, seekergroup2;
Global Layer border,illum;
Global Text time, time2, time_s2, time2_s2, artistT, titleT, albumT, numT, alternateT;
Global Vis visu;
Global Timer SongTimeT,Blender;
Global Int fullTime, cacheTime,i;
Global String newArtist;
//Global updatedTitle;


updatedisplay()
{
 string pre_title = System.getPlayItemMetaDataString("Title");
 string pre_artist = System.getPlayItemMetaDataString("Artist");
 string pre_album = System.getPlayItemMetaDataString("Album");
 string filename = System.getPlayItemMetaDataString("Filename");
 string c = System.getPlayItemString();

 if ((pre_title == "") || (pre_artist == ""))
 {
	titleT.hide();
	artistT.hide();
	albumT.hide();

	alternateT.setText(removePath(c));

	alternateT.show();
 }
 else
 {
	titleT.show();
	artistT.show();
	// Bug bypass using show and hide
	if (pre_album != "")
	albumT.show();
	else
	albumT.hide();

	alternateT.hide();
 }

 titleT.setText(pre_title);
 artistT.setText(pre_artist);
 albumT.setText(pre_album);

}

System.onScriptLoaded()
{
  Layout mainnormal = getContainer("Main").getLayout("normal");

  Pause = mainnormal.getObject("Pause");
  Play = mainnormal.getObject("Play");
  next = mainnormal.getObject("Next");
  prev = mainnormal.getObject("prev");
  stop = mainnormal.getObject("Select");
  playstatus = mainnormal.getObject("playstatus");

  infogroup = System.getContainer("main").getLayout("normal").getObject("infowindow");
  seekergroup = System.getContainer("main").getLayout("normal").getObject("seekerwindow");
  seekergroup2 = System.getContainer("main").getLayout("normal").getObject("seekerwindow2");
  border = infogroup.getObject("seekerborder");
  time = seekergroup.getObject("timer");
  time2 = seekergroup.getObject("timer2");

  time_s2 = seekergroup2.getObject("timer_s2");
  time2_s2 = seekergroup2.getObject("timer2_s2");

  illum = mainnormal.getObject("illuminator");
  illum.setalpha(0);

  artistT = infogroup.getObject("songArtist");
  titleT = infogroup.getObject("songTitle");
  albumT = infogroup.getObject("songAlbum");
  numT = infogroup.getObject("songNum");

  alternateT = infogroup.getObject("alternate_ticker");
  alternateT.hide();

  time.hide();
  time2.hide();

  SongTimeT = new timer;
  SongTimeT.setDelay(100);
  SongTimeT.start();

  if (getstatus() == 1)
  {
    time.show();
    time2.show();
    playstatus.setXMLParam("image","status.play");
  	playstatus.show();
  }
  else if (getstatus() == -1)
  {
    time.show();
    time2.show();
    playstatus.setXMLParam("image","status.pause");
  	playstatus.show();
  }
  UpdateDisplay();

  PlDir.showCurrentlyPlayingEntry();
}

System.onTitlechange(String newTitle)
{
  UpdateDisplay();
}

SongTimeT.onTimer()
{
  cacheTime = getPosition();
  fullTime = getPlayItemLength();

  time.setText(integerToTime(cacheTime));
  time2.setText("-" + integerToTime(fulltime-cacheTime));

  time_s2.setText(integerToTime(cacheTime));
  time2_s2.setText("-" + integerToTime(fulltime-cacheTime));
}

// If winamp is playing, hides the play button and shows pause
System.onPlay()
{
  time.show();
  time2.show();
  playstatus.setXMLParam("image","status.play");
  playstatus.show();
}


// If winamp is paused, hides pause and shows play
System.onPause()
{
  playstatus.setXMLParam("image","status.pause");
  playstatus.show();
}

// If winamp is stopped, shows play and hides pause
System.onStop()
{
  time.hide();
  time2.hide();

  playstatus.hide();
}


// After paused and button is again pressed starting play, will show pause and hide play
System.onresume()
{
  playstatus.setXMLParam("image","status.play");
  playstatus.show();
}