#include "../../../lib/std.mi"
#include "../../../lib/pldir.mi"

// ----------------------------------------------------------------------------
// Modified to avoid the cyclic feature of the volume slider
// And to make the volume change reletive to current volume insted of location
// On the slider. Also removed 4 unused varriables.
// ----------------------------------------------------------------------------
// When?	: 4/7/2003
// Who? 	: David Kohen (winamp@dudy.mine.nu)
// ----------------------------------------------------------------------------

// Functions
//------------------------------------------------------------
Function updateVolume(int v);
Function updatePosition(int v);
Function initVolume();

// Globals
//------------------------------------------------------------
Global AnimatedLayer Volume;
Global Layer VolumeInfo, volseekerfull;
Global Map volMap;
Global Map menuMap;
Global Map nextMap;
Global Map playMap;
Global Map prevMap;
//Global Slider HiddenVolume;
Global Int VolChanging, mousedown, VolFrames, Volflag;
Global Group VWin;
Global float OldValue, diff;
Global float OldValue2, diff2;

// onload
//------------------------------------------------------------
System.onScriptLoaded() {

	volMap = new Map;
	volMap.loadMap("Volume.map");

	menuMap = new Map;
	menuMap.loadMap("menu.map");

	nextMap = new Map;
	nextMap.loadMap("next.map");

	playMap = new Map;
	playMap.loadMap("play.map");

	prevMap = new Map;
	prevMap.loadMap("prev.map");

	Volume = System.getContainer("main").getLayout("normal").getObject("Volume-Ani-Layer");
	VolumeInfo = System.getContainer("main").getLayout("normal").getObject("Volume-Ani-Info");
	VWin = System.getContainer("main").getLayout("normal").getObject("volumewindow");
	volseekerfull = VWin.getObject("vol-seekerfull");

	initVolume();
}

// onunload
//------------------------------------------------------------
System.onScriptUnloading() {
	delete volMap;
}

// Initializes volume anim
//------------------------------------------------------------
initVolume() {

	VolumeInfo.setAlpha(0);

	VolChanging = 0;
	VolFrames = Volume.getLength();
	VolFrames = VolFrames - 1;

	float u;
	u = System.getVolume();
	u = u / 255;
	int k = u * VolFrames;
	Volume.gotoFrame(k);

	float nwf = 56/255;
	int nwi = nwf * System.Getvolume();

	volseekerfull.setXMLParam("w",IntegerToString(nwi));
}

//------------------------------------------------------------
// Volume functions
//------------------------------------------------------------

Volume.onMouseMove(int x, int y)
{
	if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
	{
		if (System.getPrivateInt("Seeking","IsOn",0) == 0)
		{
			VolChanging = 1;

			if ((VolChanging) && (Mousedown))
	        {
                x = x - Volume.getLeft();
                y = y - Volume.getTop();

                if (volMap.inRegion(x, y)) {
                    float v = volMap.getValue(x, y);
                    if (OldValue != -1) {
                        float Diff = OldValue - v;
                        float NewVol = System.getVolume() - Diff;
                        if ((Diff < -200) || (Diff > 200)) {
                            NewVol = System.getVolume();
                        }

                        if ((NewVol >= 254) && (NewVol > OldValue))
                        {
                            NewVol = System.getVolume();
                        }

                        updateVolume(NewVol);
                        OldValue = v;
                    }
                    else {
                        OldValue = v;
                    }
                }
                else {
                    OldValue = -1;
                }
            }
        }
		else
		{
			if (Mousedown)
			{
                x = x - Volume.getLeft();
                y = y - Volume.getTop();

				if (volMap.inRegion(x, y))
				{
                    float v = volMap.getValue(x, y);
                    if (OldValue2 != -1)
                    {
                        float Diff2 = OldValue2 - (v*500);
                        float NewPos = (System.getPosition()) - Diff2;
                        if ((Diff2 < -200*500) || (Diff2 > 200*500))
                        {
                            NewPos = System.getPosition();
                        }

                        updatePosition(NewPos);
                        OldValue2 = v*500;
                    }
                    else
                    {
                        OldValue2 = v*500;
                    }
                }
                else
                {
                    OldValue2 = -1;
                }
            }
		}
	}
}


Volume.onLeftButtonDown(int x, int y) {
	//if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0) VolChanging = 1;

	mousedown = 1;

	x = x - Volume.getLeft();
	y = y - Volume.getTop();
	if (volMap.inRegion(x, y))
	{
		OldValue = volMap.getValue(x, y);
		OldValue2 = volMap.getValue(x, y)*500;
	}
	else
	{
		OldValue = -1;
		Oldvalue2 = -1;
	}
}


Volume.onLeftButtonUp(int x, int y) {

	mousedown = 0;

    if (System.getPrivateInt("Seeking","IsOn",0) == 0)
    {
		if (System.getPrivateInt("Seeking","IsOn",0) == 0)
		{
			VolChanging = 1;

            if (VolChanging) {
                x = x - Volume.getLeft();
                y = y - Volume.getTop();

                if (volMap.inRegion(x, y)) {
                    float v = volMap.getValue(x, y);
                    if (OldValue != -1) {
                        float Diff = OldValue - v;
                        float NewVol = System.getVolume() - Diff;
                        if ((Diff < -200) || (Diff > 200)) {
                            NewVol = System.getVolume();
                        }
                        updateVolume(NewVol);
                        OldValue = v;
                    }
                    VolChanging = 0;
                }
            }
        }
        else
        {
                x = x - Volume.getLeft();
                y = y - Volume.getTop();

                if (volMap.inRegion(x, y)) {
                    float v = volMap.getValue(x, y);
                    if (OldValue2 != -1) {
                        float Diff2 = OldValue2 - (v*500);
                        float NewPos = System.getVolume() - Diff2;
                        if ((Diff2 < -200*500) || (Diff2 > 200*500)) {
                            NewPos = System.getVolume();
                        }
                        updatePosition(NewPos);
                        OldValue2 = v;
                    }
                }
        }
    }
}


updateVolume(float v) {

if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
{
	if (v >= 0)
	{
		float k = v / 255;
		int g = k * VolFrames;
		Volume.gotoFrame(g);

		System.setVolume(v);

		float nwf = 56/252;
		int nwi = nwf * System.Getvolume();

		volseekerfull.setXMLParam("w",IntegerToString(nwi));
	}
}
}

updatePosition(float v) {
	if (v >= 0)
	{
		System.seekto(v);
	}
}

System.onVolumeChanged(int newvol)
{
	Float f = newvol;
	Float sf = f/2.55;
	f = f * VolFrames;
	f = f / 255;
	Volume.gotoFrame(f);
}